SCRIPT_NAME = "resolve_internal_links.lua"
os.setlocale("C")

local Inlines = pandoc.Inlines

return {
  { Link = function(l)
    -- early return for external links
    if l.target:find("^https?%:%/%/") then return end
    if l.target:find("^mailto%:") then return end

    local fp, slug, anchor = l.target:match("^((.+)%.md)#?(.*)$")
    -- early return for non markdown files
    if not fp then return end

    local f = io.open(fp)
    -- early return for broken internal links
    if f == nil then return l.content else f:close() end -- @todo maybe log broken internal links

    local internal_link = l:clone()
    internal_link.target = ("#%s%s"):format(slug, anchor)

    l.content = "[->]"
    l.target = ("%s.html#%s"):format(slug, anchor)
    l.classes:insert("internal-next")

    return Inlines({ internal_link, l })
  end }
}
